<script setup lang="ts">
import { ref } from 'vue';

import { useVbenModal } from '@vben/common-ui';

import { message } from 'ant-design-vue';

import UserView from '#/views/system/user/index.vue';

const emit = defineEmits<{ selectUser: [any] }>();

const [BasicModal, modalApi] = useVbenModal({
  fullscreenButton: false,
  draggable: true,
  onCancel: handleCancel,
  onConfirm: handleConfirm
});
const userView = ref();

async function handleConfirm() {
  try {
    modalApi.modalLoading(true);
    const tableSelect = userView.value.tableSelect();
    if (tableSelect.length > 1) {
      message.error('最多只能选择一个成员！');
      modalApi.modalLoading(false);
      return false;
    }
    emit('selectUser', tableSelect[0]);
    await handleCancel();
  } catch (error) {
    console.error(error);
  } finally {
    modalApi.modalLoading(false);
  }
}

async function handleCancel() {
  modalApi.close();
}
</script>

<template>
  <BasicModal :fullscreen-button="true" class="w-[800px]">
    <UserView ref="userView" />
  </BasicModal>
</template>

<style scoped></style>
